.pykx.i.prevCtx:system"d";
system"d .pykx";

// This env var tells PyKX that it should not load embedded q, as q symbols are already
// defined in the process.
setenv[`PYKX_UNDER_Q;"true"];

libpythonErrMsg:"Failed to find libpython to start PyKX - ensure your Python environment is properly configured and activated";

// Get all necessary Python environment info from a single call to whatever `python` is on $PATH.
// It is the responsibility of the user to ensure that the first `python` on their $PATH starts the
// desired Python environment, as we try to replicate that particular Python environment.
pyEnvInfo:@[system;"python -c 'import find_libpython, os, sys; print(sys.executable, find_libpython.find_libpython(), *sys.path, sep=os.linesep)'";{'libpythonErrMsg}];
// XXX: We assume that if the above command fails, it's because find_libpython could not be found
// or otherwise failed.
if[any pyEnvInfo[1] in ("";"None");'libpythonErrMsg]; // find_libpython can also return "None"
i.pyPath:2 _ pyEnvInfo;

// Find the path to where PyKX is installed, likely in site-packages
pykxDir:,[;"/pykx"]i.pyPath first where `pykx in/:(key{$[null x;`:.;x]}@)each hsym`$i.pyPath;
if[pykxDir~"/pykx";
    '"Failed to find pykx - ensure your Python environment is properly configured and activated"];

2:[hsym`$pykxDir,"/python";(`k_init_python;1)] `$pyEnvInfo 1; // Initialize the Python interpreter

i.pyrun:2:[hsym`$pykxDir,"/pykx";(`k_pyrun;3)];
pyevalNoRet:i.pyrun . 00b;
pyeval:i.pyrun . 10b;
pyexec:i.pyrun . 11b;

i.exeCode:"sys.executable = '",pyEnvInfo[0],"';";
i.pathCode:"sys.path = [",(raze{"'",x,"',"}each i.pyPath),"];";
pyexec"import site, sys;",i.exeCode,i.pathCode,"site.main();import pykx";

console:{pyexec"pykx.console.InteractiveConsole(globals()).interact(banner='', exitmsg='')"};

system"d ",string .pykx.i.prevCtx;
